//
//  Symbol.swift
//  MorseTutor
//

import Foundation

struct Symbol {
    let keyboardInput: String
    let displayLabel: String
    let ditDah: String
    
    static let minG4FONOrdinal = 0, maxG4FONOrdinal = 42

    /* This sequence, 0 == K and 42 == <AR>
       K M R S U A P T L O
       W I . N J E F 0 Y ,
       V G 5 / Q 9 Z H 3 8
       B ? 4 2 7 C 1 D 6 X
       <BT> <SK> <AR> */
    init?(sequenceG4FON: Int) {
        switch sequenceG4FON {
        case  0: keyboardInput = "K"; ditDah = "-.-"
        case  1: keyboardInput = "M"; ditDah = "--"
        case  2: keyboardInput = "R"; ditDah = ".-."
        case  3: keyboardInput = "S"; ditDah = "..."
        case  4: keyboardInput = "U"; ditDah = "..-"
        case  5: keyboardInput = "A"; ditDah = ".-"
        case  6: keyboardInput = "P"; ditDah = ".--."
        case  7: keyboardInput = "T"; ditDah = "-"
        case  8: keyboardInput = "L"; ditDah = ".-.."
        case  9: keyboardInput = "O"; ditDah = "---"
        case 10: keyboardInput = "W"; ditDah = ".--"
        case 11: keyboardInput = "I"; ditDah = ".."
        case 12: keyboardInput = "."; ditDah = ".-.-.-"
        case 13: keyboardInput = "N"; ditDah = "-."
        case 14: keyboardInput = "J"; ditDah = ".---"
        case 15: keyboardInput = "E"; ditDah = "."
        case 16: keyboardInput = "F"; ditDah = "..-."
        case 17: keyboardInput = "0"; ditDah = "-----"
        case 18: keyboardInput = "Y"; ditDah = "-.--"
        case 19: keyboardInput = ","; ditDah = "--..--"
        case 20: keyboardInput = "V"; ditDah = "...-"
        case 21: keyboardInput = "G"; ditDah = "--."
        case 22: keyboardInput = "5"; ditDah = "....."
        case 23: keyboardInput = "/"; ditDah = "-..-."
        case 24: keyboardInput = "Q"; ditDah = "--.-"
        case 25: keyboardInput = "9"; ditDah = "----."
        case 26: keyboardInput = "Z"; ditDah = "--.."
        case 27: keyboardInput = "H"; ditDah = "...."
        case 28: keyboardInput = "3"; ditDah = "...--"
        case 29: keyboardInput = "8"; ditDah = "---.."
        case 30: keyboardInput = "B"; ditDah = "-..."
        case 31: keyboardInput = "?"; ditDah = "..--.."
        case 32: keyboardInput = "4"; ditDah = "....-"
        case 33: keyboardInput = "2"; ditDah = "..---"
        case 34: keyboardInput = "7"; ditDah = "--..."
        case 35: keyboardInput = "C"; ditDah = "-.-."
        case 36: keyboardInput = "1"; ditDah = ".----"
        case 37: keyboardInput = "D"; ditDah = "-.."
        case 38: keyboardInput = "6"; ditDah = "-...."
        case 39: keyboardInput = "X"; ditDah = "-..-"
        case 40: keyboardInput = "BT"; ditDah = "-...-"
        case 41: keyboardInput = "SK"; ditDah = "...-.-"
        case 42: keyboardInput = "AR"; ditDah = ".-.-."
        default: return nil
        }
        
        if (keyboardInput as NSString).length == 1 {
            displayLabel = keyboardInput
        }
        else {
            switch keyboardInput {
            case "BT": displayLabel = "B\u{0305}T\u{0305}"
            case "SK": displayLabel = "S\u{0305}K\u{0305}"
            default: displayLabel = "A\u{0305}R\u{0305}" // avoid spurious compiler errors
            }
        }
    }

    init?(space: String) {
        if space != " " {
            return nil
        }
        
        keyboardInput = " "
        displayLabel = " "
        ditDah = " "
    }
}